#!/usr/bin/perl -w

package MainMenu;

BEGIN {
    use src::MymoneyUI;
};


use strict;
use POSIX qw(strftime);

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gnome2;

use lib "./";
use lib::Table;
use lib::Databaze;
use lib::Seznam;
use lib::ZmenaAgendyRoku;
use lib::Login;
use lib::NastaveniAgendy;
use lib::NastaveniUcetnihoRoku;
use lib::MainCfg;
use lib::UzivatelskeNastaveni;
use lib::NovaAgenda;
use lib::NovyUcetniRok;
use lib::DanovaKalkulacka;
use lib::VypocetPenale;
use lib::FakturaVystavena;
use lib::Adresar;



my $MyUI;
my %MyMoney=();

sub run {
    my ($class, %params) = @_;

    %MyMoney=%params;
    
    my $window=$class;
    $MyUI=$window;
    $MyMoney{'MainMenu'}=$MyUI;
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox2'};
    $MyUI->FORM->{'ucetni_datum'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'ucetni_datum'}->set_border_width('5');
    $MyUI->FORM->{'ucetni_datum'}->show;
    $window->FORM->{'frame4'}->add($MyUI->FORM->{'ucetni_datum'});
    
    
    $window->FORM->{'home_page'}=Gnome2::HRef->new ("http://mymoney.ordoz.com/", "mymoney.ordoz.com");
    $window->FORM->{'fixed1'}->put($window->FORM->{'home_page'}, 96, 32);
    $window->FORM->{'home_page'}->hide;
    
    $MyUI->init;
    
    # nedodelane moduly - Agenda
    $MyUI->FORM->{'item41'}->set_sensitive(0);
    $MyUI->FORM->{'item42'}->set_sensitive(0);
    # nedodelane moduly - Ucetnictvi
    $MyUI->FORM->{'item48_P'}->set_sensitive(0);
    $MyUI->FORM->{'item164_J'}->set_sensitive(0);
    $MyUI->FORM->{'item73_P'}->set_sensitive(0);
    $MyUI->FORM->{'item74_P'}->set_sensitive(0);
    $MyUI->FORM->{'item326_J'}->set_sensitive(0);
    $MyUI->FORM->{'item75'}->set_sensitive(0);
    $MyUI->FORM->{'item78'}->set_sensitive(0);
    $MyUI->FORM->{'item249'}->set_sensitive(0);
    $MyUI->FORM->{'item80_P'}->set_sensitive(0);
    $MyUI->FORM->{'item81_P'}->set_sensitive(0);
    $MyUI->FORM->{'item326_J'}->set_sensitive(0);
    $MyUI->FORM->{'item82'}->set_sensitive(0);
    $MyUI->FORM->{'item84_P'}->set_sensitive(0);
    $MyUI->FORM->{'item85_P'}->set_sensitive(0);
    $MyUI->FORM->{'item327_J'}->set_sensitive(0);
    $MyUI->FORM->{'item86'}->set_sensitive(0);
    $MyUI->FORM->{'item87'}->set_sensitive(0);
    $MyUI->FORM->{'item88'}->set_sensitive(0);
    $MyUI->FORM->{'item90'}->set_sensitive(0);
    $MyUI->FORM->{'item91'}->set_sensitive(0);
    $MyUI->FORM->{'item92'}->set_sensitive(0);
    $MyUI->FORM->{'item93'}->set_sensitive(0);
    $MyUI->FORM->{'item94'}->set_sensitive(0);
    $MyUI->FORM->{'item96'}->set_sensitive(0);
    $MyUI->FORM->{'item97'}->set_sensitive(0);
    $MyUI->FORM->{'item98'}->set_sensitive(0);
    $MyUI->FORM->{'item99'}->set_sensitive(0);
    $MyUI->FORM->{'item101'}->set_sensitive(0);
    $MyUI->FORM->{'item102'}->set_sensitive(0);
    $MyUI->FORM->{'item104'}->set_sensitive(0);
    $MyUI->FORM->{'item55'}->set_sensitive(0);
    $MyUI->FORM->{'item59'}->set_sensitive(0);
    $MyUI->FORM->{'item60'}->set_sensitive(0);
    $MyUI->FORM->{'item105'}->set_sensitive(0);
    $MyUI->FORM->{'item106'}->set_sensitive(0);
    $MyUI->FORM->{'item107'}->set_sensitive(0);
    $MyUI->FORM->{'item108'}->set_sensitive(0);
    $MyUI->FORM->{'item62'}->set_sensitive(0);
    $MyUI->FORM->{'item67'}->set_sensitive(0);
    $MyUI->FORM->{'item68'}->set_sensitive(0);
    # nedodelane moduly - Fakturace
    $MyUI->FORM->{'item111'}->set_sensitive(0);
    $MyUI->FORM->{'item113'}->set_sensitive(0);
    $MyUI->FORM->{'item114'}->set_sensitive(0);
    $MyUI->FORM->{'item115'}->set_sensitive(0);
    # nedodelane moduly - Adresar
    $MyUI->FORM->{'item117'}->set_sensitive(0);
    $MyUI->FORM->{'item119'}->set_sensitive(0);
    $MyUI->FORM->{'item120'}->set_sensitive(0);
    $MyUI->FORM->{'item122'}->set_sensitive(0);
    $MyUI->FORM->{'item125'}->set_sensitive(0);
    #nedodelane moduly - Objednavky
    $MyUI->FORM->{'item275'}->set_sensitive(0);
    $MyUI->FORM->{'item276'}->set_sensitive(0);
    $MyUI->FORM->{'item277'}->set_sensitive(0);
    $MyUI->FORM->{'item279'}->set_sensitive(0);
    $MyUI->FORM->{'item280'}->set_sensitive(0);
    $MyUI->FORM->{'item281'}->set_sensitive(0);
    $MyUI->FORM->{'item283'}->set_sensitive(0);
    $MyUI->FORM->{'item284'}->set_sensitive(0);
    $MyUI->FORM->{'item285'}->set_sensitive(0);
    $MyUI->FORM->{'item287'}->set_sensitive(0);
    $MyUI->FORM->{'item288'}->set_sensitive(0);
    $MyUI->FORM->{'item289'}->set_sensitive(0);
    $MyUI->FORM->{'item291'}->set_sensitive(0);
    $MyUI->FORM->{'item292'}->set_sensitive(0);
    $MyUI->FORM->{'item293'}->set_sensitive(0);
    $MyUI->FORM->{'item295'}->set_sensitive(0);
    $MyUI->FORM->{'item296'}->set_sensitive(0);
    $MyUI->FORM->{'item297'}->set_sensitive(0);
    $MyUI->FORM->{'item299'}->set_sensitive(0);
    $MyUI->FORM->{'item301'}->set_sensitive(0);
    # nedodelane moduly - Pomucky
    $MyUI->FORM->{'item133'}->set_sensitive(0);
    # nedodelane moduly - Nastroje
    $MyUI->FORM->{'item127'}->set_sensitive(0);
    $MyUI->FORM->{'item128'}->set_sensitive(0);
    
    $MyMoney{'MainCfg'}->window_open("MainMenu",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
};

sub init {
    $MyUI->FORM->{'button_agenda'}->set_label($MyMoney{'AgendaData'}->get('ob_nazev'));
    $MyUI->FORM->{'button_ucetni_rok'}->set_label($MyMoney{'RokData'}->get('ucetni_rok'));
    my $jmeno=$MyMoney{'Uzivatel'}->get('jmeno');
    if($jmeno eq "-") {
        $jmeno="uživatel beze jména";
    };
    $MyUI->FORM->{'button_uzivatel'}->set_label($jmeno);
    foreach $_ (keys(%{$MyUI->FORM})) {
        if(/^item([0-9]*)_[PJ]$/) {
            if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'P') {
                if(/_J$/) {
                    $MyUI->FORM->{$_}->hide;
                } else {
                    $MyUI->FORM->{$_}->show;
                };
            } else {
                if(/_J$/) {
                    $MyUI->FORM->{$_}->show;
                } else {
                    $MyUI->FORM->{$_}->hide;
                };
            };
        };
    };
};

sub quit {
    $MyMoney{'MainCfg'}->window_close("MainMenu",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
    kill("TERM",$$);
};

sub seznam_stredisek {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('strediska',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_ciselnych_rad {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('ciselne_rady',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_cinnosti {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('cinnosti',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_zakazek {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('zakazky',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_uctu_pokladen {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('ucty_pokladny',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_peneznich_ustavu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('banky',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_statu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('staty',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_konsym {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('konstantni_symboly',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};


sub seznam_psc {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('psc',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub uctova_osnova {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('uctova_osnova',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_ucetnich_pohybu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('ucetni_pohyby',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};


sub seznam_cleneni {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('cleneni',"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_predkontaci {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('predkontace_'.$MyMoney{'RokData'}->get('typ_ucetnictvi'),"cfg"=>[%MyMoney]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub zmena_agendy_roku {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $ZmenaAgendyRoku=new ZmenaAgendyRoku;
    if($ZmenaAgendyRoku->run(%MyMoney)) {
        my %selected=$ZmenaAgendyRoku->get_selected;
        $MyMoney{'AgendaData'}->load("id='".$selected{'agenda'}."'");
        $MyMoney{'RokData'}->load("id='".$selected{'rok'}."'");
        $MyMoney{'MainCfg'}->set('agenda',$selected{'agenda'});
        $MyMoney{'MainCfg'}->set('rok',$selected{'rok'});
        # kontrola tabulek
        my $Tables=new Table('',%MyMoney);
        if(!$Tables->check("^a".$MyMoney{'AgendaData'}->get('id')."_")) {
            print("Error: neprosla kontrola tabulek agendy!\n");
            kill("TERM",$$);
        };
        if(!$Tables->check("^r".$MyMoney{'RokData'}->get('id')."_")) {
            print("Error: neprosla kontrola tabulek roku!\n");
            kill("TERM",$$);
        };

        #
        # Nacteni/vytvoreni uzivatelova nastaveni v ramci roku
        #
        if(!$MyMoney{'UzivatelskeNastaveni'}->load("user_id=".$MyMoney{'Uzivatel'}->get('id'),1)) {
            my $rok=$MyMoney{'RokData'}->get('ucetni_rok');
            if(! -d "./data/rok/".$rok) {
                my @roky=`ls -1 ./data/rok/`;
                my $nejvyssi_rok=0;
                foreach $_ (@roky) {
                    chomp;
                    $_=int($_);
                    if(-d "./data/rok/".$_) {
                        if($_>$nejvyssi_rok) {
                            $nejvyssi_rok=$_;
                        };
                    };
                };
                my $Dialog=new Dialog;
                if($nejvyssi_rok) {
                        if(!$Dialog->show('text'=>"Nebyly nalezeny připravené konfigurace uživatelského nastavení pro rok ".$rok.".\n\nChcete načíst konfigurace z nejvyššího známeho roku ".$nejvyssi_rok."?",'type'=>'question')) {
                            kill("TERM",$$);
                        };
                        $rok=$nejvyssi_rok;
                } else {
                    $Dialog->show('text'=>"Nebyly nalezeny připravené konfigurace uživatelského nastavení!",'type'=>'error');
                    kill("TERM",$$);
                };
            };
            print("Vytvarim nove uzivatelske nastaveni v ramci roku...\n");
            $MyMoney{'UzivatelskeNastaveni'}->read_defaults($rok);
            $MyMoney{'UzivatelskeNastaveni'}->set("user_id",$MyMoney{'Uzivatel'}->get('id'));
            $MyMoney{'UzivatelskeNastaveni'}->save;
        };
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub prehlaseni_uzivatele {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Login=new Login;
    my $Uzivatel;
    if(($Uzivatel=$Login->run(%MyMoney))) {
        $MyMoney{'Uzivatel'}=$Uzivatel;
        #kontrola pristupovych prav
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub vypocet_penale {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $VypocetPenale=new VypocetPenale;
    $VypocetPenale->run(%MyMoney);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub danova_kalkulacka {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $DanovaKalkulacka=new DanovaKalkulacka;
    $DanovaKalkulacka->run(%MyMoney);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_uzivatelske_nastaveni_activate {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $UzivatelskeNastaveni=new UzivatelskeNastaveni;
    if($UzivatelskeNastaveni->show(%MyMoney)) {
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_nastaveni_ucetniho_roku_activate {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $NastaveniUcetnihoRoku=new NastaveniUcetnihoRoku;
    if($NastaveniUcetnihoRoku->run('',%MyMoney)) {
        $MyUI->init;  
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_nastaveni_agendy_activate {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $NastaveniAgendy=new NastaveniAgendy;
    if($NastaveniAgendy->run('',%MyMoney)) {
        $MyUI->init;  
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub vystaveni_faktury {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $FakturaVystavena=new FakturaVystavena;
    $FakturaVystavena->pridat(%MyMoney);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_nastaveni_databaze_activate {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    if($MyMoney{'MainCfg'}->run) {
        my $Databaze=new Databaze(%MyMoney);
        while(!$Databaze->DBTest($MyMoney{'MainCfg'})) {
            $MyMoney{'MainCfg'}->run;
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};


sub on_about_activate {
    $MyUI->TOPLEVEL->hide;
    my $name="MyMoney";
    my $version="0.0.3 (alpha)";
    my $copyright="© 2004 - 2005 Michal Hučík - ORDOZ <ordoz\@ordoz.com>";
    my $comments="MyMoney je program pro vedení agendy jednoduchého, nebo podvojného účetnictví.";
    my $authors="Michal Hučík - ORDOZ <ordoz\@ordoz.com>";
    my $documenters="Hledají se ...";
    my $translator_credits="Hledají se ...";
    my $logo_pixbuf=Gtk2::Gdk::Pixbuf->new_from_file("./pixmaps/mymoney.xpm");
    my $w=Gnome2::About->new ($name, $version, $copyright, $comments, $authors, $documenters, $translator_credits, $logo_pixbuf);
    $w->set_title("O aplikaci");
    $w->set_modal(0);
    $w->set_position('center');
    $w->signal_connect("unrealize" => sub {Gtk2->main_quit;});
    $w->show_all;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    $MyUI->TOPLEVEL->show;
};

sub nova_agenda {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $NovaAgenda=new NovaAgenda;
    if($NovaAgenda->run(%MyMoney)) {
        
        my %created=$NovaAgenda->get_created;
        $MyMoney{'AgendaData'}->load("id='".$created{'agenda'}."'");
        $MyMoney{'RokData'}->load("id='".$created{'rok'}."'");
        $MyMoney{'MainCfg'}->set('agenda',$created{'agenda'});
        $MyMoney{'MainCfg'}->set('rok',$created{'rok'});
        # kontrola tabulek
        my $Tables=new Table('',%MyMoney);
        if(!$Tables->check("^a".$MyMoney{'AgendaData'}->get('id')."_")) {
            print("Error: neprosla kontrola tabulek agendy!\n");
            kill("TERM",$$);
        };
        if(!$Tables->check("^r".$MyMoney{'RokData'}->get('id')."_")) {
            print("Error: neprosla kontrola tabulek roku!\n");
            kill("TERM",$$);
        };
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub novy_ucetni_rok {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $NovyUcetniRok=new NovyUcetniRok;
    my $vytvoreny_rok=$NovyUcetniRok->run($MyMoney{'AgendaData'}->get('id'),%MyMoney);
    if($vytvoreny_rok) {
        $MyMoney{'RokData'}->load("id='".$vytvoreny_rok."'");
        $MyMoney{'MainCfg'}->set('rok',$vytvoreny_rok);
        # kontrola tabulek
        my $Tables=new Table('',%MyMoney);
        if(!$Tables->check("^a".$MyMoney{'AgendaData'}->get('id')."_")) {
            print("Error: neprosla kontrola tabulek agendy!\n");
            kill("TERM",$$);
        };
        if(!$Tables->check("^r".$MyMoney{'RokData'}->get('id')."_")) {
            print("Error: neprosla kontrola tabulek roku!\n");
            kill("TERM",$$);
        };
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub domovska_stranka_programu {
    $MyUI->FORM->{'home_page'}->clicked;
};

sub seznam_vystavenych_faktur {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('vystavene_faktury',"cfg"=>[%MyMoney],"delete_butt"=>0,"storno_butt"=>1,"smazat_butt"=>1,"uzamceni_butt"=>1);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub dead_locks {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('dead_locks',"cfg"=>[%MyMoney],"upravit_butt"=>0,"pridat_butt"=>0,"kopirovat_butt"=>0);
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub seznam_adresare {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Adresar=new Adresar;
    $Adresar->run('cfg'=>{%MyMoney},'selection_mode'=>'none','selected_firmy'=>[undef]);
    $MyUI->{'TOPFORM'}->set_sensitive(1);    
};

1;
