#!/usr/bin/perl -w

package UzivatelskeNastaveni;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
#use Gnome2;

use lib "./";
use lib::Table;
use lib::Locks;

my $MyUI;
my %MyMoney;
my $retval;
my $UzivatelskeNastaveni;
my $Locks;

sub show {
    my ($class, %params) = @_;
    $retval=0;    
    my $window=$class;
    $MyUI=$window;
    %MyMoney=%params;

    $Locks=0;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_UzivatelskeNastaveni',"id='".$MyMoney{'UzivatelskeNastaveni'}->get('id')."'")) {
        $MyUI->FORM->{'button_ok'}->set_sensitive(0);
    };

    
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox42'};
    
    $UzivatelskeNastaveni=$MyMoney{'UzivatelskeNastaveni'};
    $UzivatelskeNastaveni->WriteToUI($MyUI->FORM);
    
    $MyUI->radiobutton_dotaz_potvrdit_toggled;
    $MyUI->radiobutton_datum_zmeneno_toggled;

    #odstranit neimplementovane moduly
    $MyUI->FORM->{'notebook14'}->remove_page(6);
    $MyUI->FORM->{'notebook14'}->remove_page(5);
    $MyUI->FORM->{'notebook14'}->remove_page(4);
    $MyUI->FORM->{'notebook14'}->remove_page(3);
    
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $MyUI->FORM->{'label301'}->hide;
        $MyUI->FORM->{'ui_predkontace'}->hide;
        $MyUI->FORM->{'button_ui_predkontace'}->hide;
        $MyUI->FORM->{'label299'}->hide;
        $MyUI->FORM->{'ui_cleneni'}->hide;
        $MyUI->FORM->{'button_ui_cleneni'}->hide;
        $MyUI->FORM->{'ui_nabidnout_zauc'}->hide;
        $MyUI->FORM->{'ui_tisk_dokl_se_zauc'}->hide;
        $MyUI->FORM->{'ui_tisk_dokl_se_zauc_text'}->hide;
        $MyUI->FORM->{'ui_tisk_danovy_dokl'}->hide;
        $MyUI->FORM->{'ui_tisk_danovy_dokl_text'}->hide;
        $MyUI->FORM->{'frame48'}->hide;
        $MyUI->FORM->{'frame90'}->show;
    } else {
        $MyUI->FORM->{'frame90'}->hide;
        $MyUI->FORM->{'label301'}->show;
        $MyUI->FORM->{'ui_predkontace'}->show;
        $MyUI->FORM->{'button_ui_predkontace'}->show;
        $MyUI->FORM->{'label299'}->show;
        $MyUI->FORM->{'ui_cleneni'}->show;
        $MyUI->FORM->{'button_ui_cleneni'}->show;
        $MyUI->FORM->{'ui_nabidnout_zauc'}->show;
        $MyUI->FORM->{'ui_tisk_dokl_se_zauc'}->show;
        $MyUI->FORM->{'ui_tisk_dokl_se_zauc_text'}->show;
        $MyUI->FORM->{'ui_tisk_danovy_dokl'}->show;
        $MyUI->FORM->{'ui_tisk_danovy_dokl_text'}->show;
        $MyUI->FORM->{'frame48'}->show;
    };
    
    $MyUI->on_up_vyd_nastaveni_typu_dok_toggled;
    $MyUI->on_up_prij_nastaveni_typu_dok_toggled;
    $MyUI->on_ub_vyd_nastaveni_typu_dok_toggled;
    $MyUI->on_ub_prij_nastaveni_typu_dok_toggled;
    $MyUI->on_uzp_zav_nastaveni_typu_dok_toggled;
    $MyUI->on_uzp_poh_nastaveni_typu_dok_toggled;
    $MyUI->on_ui_nastaveni_typu_dok_toggled;
    $MyUI->on_fz_vyd_nastaveni_typu_dok_toggled;
    $MyUI->on_fz_prij_nastaveni_typu_dok_toggled;
    $MyUI->on_fs_vyd_pouzit_typ_toggled;
    $MyUI->on_fs_prij_pouzit_typ_toggled;
    $MyUI->on_fp_vyd_vytvorit_dokl_toggled;
    $MyUI->on_fp_prij_vytvorit_dokl_toggled;

    $MyMoney{'MainCfg'}->window_open("UzivatelskeNastaveni",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retval);
};


sub radiobutton_datum_zmeneno_toggled {
    if($MyUI->FORM->{'automaticka_zmena_data_Z'}->get_active) {
        $MyUI->FORM->{'table28'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'table28'}->set_sensitive(0);
    };
};

sub radiobutton_dotaz_potvrdit_toggled {
    if($MyUI->FORM->{'dotaz_potvrdit_Z'}->get_active) {
        $MyUI->FORM->{'dotaz_zavrit_po'}->set_sensitive(1);
        $MyUI->FORM->{'znovu_se_zeptat_po'}->set_sensitive(1);
        $MyUI->FORM->{'label219'}->set_sensitive(1);
        $MyUI->FORM->{'label220'}->set_sensitive(1);
        $MyUI->FORM->{'dotaz_potvrdit_po'}->set_sensitive(0);
        $MyUI->FORM->{'label218'}->set_sensitive(0);
    } else {
        if($MyUI->FORM->{'dotaz_potvrdit_A'}->get_active) {
            $MyUI->FORM->{'dotaz_zavrit_po'}->set_sensitive(0);
            $MyUI->FORM->{'znovu_se_zeptat_po'}->set_sensitive(0);
            $MyUI->FORM->{'label219'}->set_sensitive(0);
            $MyUI->FORM->{'label220'}->set_sensitive(0);
            $MyUI->FORM->{'dotaz_potvrdit_po'}->set_sensitive(1);
            $MyUI->FORM->{'label218'}->set_sensitive(1);
        } else {
            $MyUI->FORM->{'dotaz_zavrit_po'}->set_sensitive(0);
            $MyUI->FORM->{'znovu_se_zeptat_po'}->set_sensitive(0);
            $MyUI->FORM->{'label219'}->set_sensitive(0);
            $MyUI->FORM->{'label220'}->set_sensitive(0);
            $MyUI->FORM->{'dotaz_potvrdit_po'}->set_sensitive(0);
            $MyUI->FORM->{'label218'}->set_sensitive(0);
        };
    };
};

sub on_UzivatelskeNastaveni_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("UzivatelskeNastaveni",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("UzivatelskeNastaveni",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $UzivatelskeNastaveni->ReadFromUI($MyUI->FORM);
    $UzivatelskeNastaveni->update;
    $MyMoney{'UzivatelskeNastaveni'}=$UzivatelskeNastaveni;
    $MyMoney{'MainCfg'}->window_close("UzivatelskeNastaveni",$MyUI->TOPLEVEL);
    $retval=1;
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_up_vyd_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'up_vyd_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'up_vyd_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_up_vyd_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'up_vyd_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_up_vyd_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_up_prij_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'up_prij_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'up_prij_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_up_prij_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'up_prij_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_up_prij_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_ub_vyd_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'ub_vyd_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'ub_vyd_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_ub_vyd_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'ub_vyd_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_ub_vyd_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_ub_prij_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'ub_prij_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'ub_prij_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_ub_prij_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'ub_prij_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_ub_prij_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_uzp_zav_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'uzp_zav_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'uzp_zav_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_uzp_zav_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'uzp_zav_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_uzp_zav_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_uzp_poh_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'uzp_poh_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'uzp_poh_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_uzp_poh_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'uzp_poh_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_uzp_poh_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_ui_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'ui_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'ui_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_ui_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'ui_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_ui_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_fz_vyd_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'fz_vyd_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'fz_vyd_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_fz_vyd_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'fz_vyd_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_fz_vyd_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_fz_prij_nastaveni_typu_dok_toggled {
    if($MyUI->FORM->{'fz_prij_nastaveni_typu_dok_T'}->get_active) {
        $MyUI->FORM->{'fz_prij_typ_dokladu'}->set_sensitive(1);
        $MyUI->FORM->{'button_fz_prij_typ_dokladu'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'fz_prij_typ_dokladu'}->set_sensitive(0);
        $MyUI->FORM->{'button_fz_prij_typ_dokladu'}->set_sensitive(0);
    };
};

sub on_fs_vyd_pouzit_typ_toggled {
    if($MyUI->FORM->{'fs_vyd_pouzit_typ_T'}->get_active) {
        $MyUI->FORM->{'fs_vyd_typ'}->set_sensitive(1);
        $MyUI->FORM->{'button_fs_vyd_typ'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'fs_vyd_typ'}->set_sensitive(0);
        $MyUI->FORM->{'button_fs_vyd_typ'}->set_sensitive(0);
    };
};

sub on_fs_prij_pouzit_typ_toggled {
    if($MyUI->FORM->{'fs_prij_pouzit_typ_T'}->get_active) {
        $MyUI->FORM->{'fs_prij_typ'}->set_sensitive(1);
        $MyUI->FORM->{'button_fs_prij_typ'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'fs_prij_typ'}->set_sensitive(0);
        $MyUI->FORM->{'button_fs_prij_typ'}->set_sensitive(0);
    };
};


sub on_ucet_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('ucty',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$MyUI->FORM->{'ucet'}->get_text])) {
        my $tbl=new Table('r_SzUcPokl',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'ucet'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'ucet'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_pokladna_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('pokladny',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$MyUI->FORM->{'pokladna'}->get_text])) {
        my $tbl=new Table('r_SzUcPokl',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'pokladna'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'pokladna'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_stredisko_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('strediska',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$MyUI->FORM->{'stredisko'}->get_text])) {
        my $tbl=new Table('r_SzStred',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'stredisko'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'stredisko'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_zakazka_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('zakazky',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$MyUI->FORM->{'zakazka'}->get_text])) {
        my $tbl=new Table('r_Zakazky',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'zakazka'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'zakazka'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_cinnost_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('cinnosti',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$MyUI->FORM->{'cinnost'}->get_text])) {
        my $tbl=new Table('r_SzCinn',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'cinnost'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'cinnost'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub button_cleneni {
    my($self,$cleneni)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('cleneni',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$MyUI->FORM->{$cleneni}->get_text])) {
        my $tbl=new Table('r_UcClnDPH',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$cleneni}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$cleneni}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_up_vyd_cleneni_clicked {
    $MyUI->button_cleneni('up_vyd_cleneni');
};

sub on_button_up_prij_cleneni_clicked {
    $MyUI->button_cleneni('up_prij_cleneni');
};

sub on_button_ub_vyd_cleneni_clicked {
    $MyUI->button_cleneni('ub_vyd_cleneni');
};

sub on_button_ub_prij_cleneni_clicked {
    $MyUI->button_cleneni('ub_prij_cleneni');
};

sub on_button_uzp_zav_cleneni_clicked {
    $MyUI->button_cleneni('uzp_zav_cleneni');
};

sub on_button_uzp_poh_cleneni_clicked {
    $MyUI->button_cleneni('uzp_poh_cleneni');
};

sub on_button_ui_cleneni_clicked {
    $MyUI->button_cleneni('ui_cleneni');
};

sub on_button_uk_cleneni_clicked {
    $MyUI->button_cleneni('uk_cleneni');
};

sub on_button_fz_vyd_cleneni_clicked {
    $MyUI->button_cleneni('fz_vyd_cleneni');
};

sub on_button_fz_prij_cleneni_clicked {
    $MyUI->button_cleneni('fz_prij_cleneni');
};

sub on_button_fp_prij_cleneni_clicked {
    $MyUI->button_cleneni('fp_prij_cleneni');
};

sub on_button_fp_vyd_cleneni_clicked {
    $MyUI->button_cleneni('fp_vyd_cleneni');
};

sub button_ciselna_rada {
    my($self,$ciselna_rada,$where)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('ciselne_rady',"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>$where,"selected_rows_by"=>"rada",selected_rows=>[$MyUI->FORM->{$ciselna_rada}->get_text])) {
        my $tbl=new Table('r_CisRady',%MyMoney);
            if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$ciselna_rada}->set_text($tbl->get('rada'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$ciselna_rada}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_up_vyd_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('up_vyd_ciselna_rada',"vp='1'");
};

sub on_button_up_prij_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('up_prij_ciselna_rada',"pp='1'");
};

sub on_button_ub_vyd_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('ub_vyd_ciselna_rada',"vu='1'");
};

sub on_button_ub_prij_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('ub_prij_ciselna_rada',"pu='1'");
};

sub on_button_uzp_zav_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('uzp_zav_ciselna_rada',"za='1'");
};

sub on_button_uzp_poh_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('uzp_poh_ciselna_rada',"po='1'");
};

sub on_button_ui_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('ui_ciselna_rada',"intd='1'");
};

sub on_button_uk_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('uk_ciselna_rada',"intd='1'");
};

sub on_button_fz_vyd_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('fz_vyd_ciselna_rada',"pf='1'");
};

sub on_button_fz_prij_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('fz_prij_ciselna_rada',"vf='1'");
};

sub on_button_fp_prij_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('fp_prij_ciselna_rada',"vp='1'");
};

sub on_button_fp_vyd_ciselna_rada_clicked {
    $MyUI->button_ciselna_rada('fp_vyd_ciselna_rada',"pp='1'");
};

sub button_predkontace {
    my($self,$predkontace,$where)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('predkontace_'.$MyMoney{'RokData'}->get('typ_ucetnictvi'),"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>$where,"selected_rows_by"=>"zkrat",selected_rows=>[$MyUI->FORM->{$predkontace}->get_text])) {
        my $tbl=new Table('r_UcPrKont_'.$MyMoney{'RokData'}->get('typ_ucetnictvi'),%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$predkontace}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$predkontace}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};


sub on_button_up_vyd_predkontace_clicked {
    my $where="typ='3'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='V'";
    };
    $MyUI->button_predkontace('up_vyd_predkontace',$where);
};

sub on_button_up_prij_predkontace_clicked {
    my $where="typ='2'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='P'";
    };
    $MyUI->button_predkontace('up_prij_predkontace',$where);
};

sub on_button_ub_vyd_predkontace_clicked {
    my $where="typ='5'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='V'";
    };
    $MyUI->button_predkontace('ub_vyd_predkontace',$where);
};

sub on_button_ub_prij_predkontace_clicked {
    my $where="typ='4'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='P'";
    };
    $MyUI->button_predkontace('ub_prij_predkontace',$where);
};

sub on_button_uzp_zav_predkontace_clicked {
    my $where="typ='6'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='V'";
    };
    $MyUI->button_predkontace('uzp_zav_predkontace',$where);
};

sub on_button_uzp_poh_predkontace_clicked {
    my $where="typ='7'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='P'";
    };
    $MyUI->button_predkontace('uzp_poh_predkontace',$where);
};

sub on_button_ui_predkontace_clicked {
    my $where="typ='8'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='V'";
    };
    $MyUI->button_predkontace('ui_predkontace',$where);
};

sub on_button_fz_vyd_predkontace_clicked {
    my $where="typ='1'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='V'";
    };
    $MyUI->button_predkontace('fz_vyd_predkontace',$where);
};

sub on_button_fz_prij_predkontace_clicked {
    my $where="typ='0'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='P'";
    };
    $MyUI->button_predkontace('fz_prij_predkontace',$where);
};

sub on_button_fp_prij_predkontace_clicked {
    my $where="typ='3'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='P'";
    };
    $MyUI->button_predkontace('fp_prij_predkontace',$where);
};

sub on_button_fp_vyd_predkontace_clicked {
    my $where="typ='2'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='V'";
    };
    $MyUI->button_predkontace('fp_vyd_predkontace',$where);
};

sub on_button_uk_kurzova_ztrata_predkontace_clicked {
    $MyUI->button_predkontace('uk_kurzova_ztrata_predkontace',"typ='V'");
};

sub on_button_uk_kurzovy_zisk_predkontace_clicked {
    $MyUI->button_predkontace('uk_kurzovy_zisk_predkontace',"typ='P'");
};

sub on_fp_vyd_vytvorit_dokl_toggled {
    if($MyUI->FORM->{'fp_vyd_vytvorit_dokl'}->get_active) {
        $MyUI->FORM->{'fp_vyd_nabidnout_dokl'}->set_sensitive(1);
        $MyUI->FORM->{'table67'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'fp_vyd_nabidnout_dokl'}->set_sensitive(0);
        $MyUI->FORM->{'table67'}->set_sensitive(0);
    };
};

sub on_fp_prij_vytvorit_dokl_toggled {
    if($MyUI->FORM->{'fp_prij_vytvorit_dokl'}->get_active) {
        $MyUI->FORM->{'fp_prij_nabidnout_dokl'}->set_sensitive(1);
        $MyUI->FORM->{'table68'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'fp_prij_nabidnout_dokl'}->set_sensitive(0);
        $MyUI->FORM->{'table68'}->set_sensitive(0);
    };
};

1;
